#ifndef __MATHEMATICS_H__
#define __MATHEMATICS_H__

//! Kleinste Quadrate
void leastSquares(const double *x, const double *y, unsigned int n, unsigned int d, double *coeff);
void leastSquares(const double *x, const double *y, unsigned int n, unsigned int d, double *coeff, double* matrix);

//! Parabel durch 3 Punkte (GSL)
void parabola(const double x_data[3], const double y_data[3], double coeff[3]);

//! Periodogram I(n,N)
double periodogram(double n, unsigned int N, const double *X);

//! Periodogrammme I(n, N), n = 1..k
void periodograms(unsigned int k, unsigned int N, const double *X, double *P);

//! Approximation des oberen (1-alpha)-Quantils der Normalverteilung 
double Z(double alpha);

//! Approximation des obereb (1-alpha)-Quantils der t-Verteilung mit ndf Freiheitsgraden. 
double T(double alpha, unsigned int ndf);

#endif

