#ifndef __Random_h__
#define __Random_h__

#include <vector>

class PRNG;

typedef unsigned int t_Index;
typedef char t_bool;

/** @dia:pos -95.768,-45.8812 */
class RandomKofN {
private:
    t_Index  *itsArray;
    t_Index  itsN;
    t_Index  itsArrayLen;
	PRNG* prng;
	
public:
    
    RandomKofN(t_Index N);
    /* An array with elements 1..N is created
     */

    t_Index Choose();
    /* RETURN: One element of the array not chosen before
     */

    t_bool Empty();
    /* OUT: The array is empty
     */

    ~RandomKofN();
};

/** @dia:pos -97.8289,-36.4851 */
class RandomKofList {
private:
    std::vector<t_Index> itsList;
	PRNG* prng;
   
public:

	RandomKofList();
	/* Random number generator is initialized.
	 */ 
	
    t_Index Choose();
    /* RETURN: One element of the array not chosen before
     */

    t_bool Empty();
    /* OUT: The array is empty
     */
    void Insert(t_Index anElem);
    // PRE: Insert was called <= aMaxListLen-1
 
    t_Index size() {
        return itsList.size();
    };

    ~RandomKofList();
};


/** @dia:pos -99.4653,-65.9859 */
class Random1ofList {
private:
    t_Index  *itsList;
    t_Index  itsListLen;
	PRNG* prng;

public:
    Random1ofList(t_Index aMaxListLen);

    void Insert(t_Index anElem);
    // PRE: Insert was called <= aMaxListLen-1

    t_Index Choose();

    ~Random1ofList();

    t_Index size() {
        return itsListLen;
    };
};

#endif // __Random_h__
